//undo / spare

final int UNDOSTEPS=20;// max # of undo steps

byte[] g_sparepage = new byte[88000];
byte[] g_swappage = new byte[88000];
byte[][] g_undob = new byte[UNDOSTEPS+1][88000];
byte[][] g_undobs = new byte[UNDOSTEPS+1][88000];
int [] g_uindex = new int[8];
int [] g_ubottom = new int[8];
int [] g_utop = new int[8];

void ustats()
{
  //a debug thingie in case the step undo does not work
  //println("UINDEX:"+g_uindex[g_spare]);
  //println("UTOP:"+g_utop[g_spare]);
  //println("UBOTTOM:"+g_ubottom[g_spare]);
}

void store_undo() //to_undo
{
  
  if(g_spare==0)g_undob[g_uindex[g_spare]]=g_map.clone();
  if(g_spare==1)g_undobs[g_uindex[g_spare]]=g_map.clone();
  g_uindex[g_spare]++;
  if(g_uindex[g_spare]>UNDOSTEPS)g_uindex[g_spare]=0;
  if(g_uindex[g_spare]==g_ubottom[g_spare]){
    g_ubottom[g_spare]++;
    if(g_ubottom[g_spare]>UNDOSTEPS)g_ubottom[g_spare]=0;
  }  
  g_utop[g_spare]=g_uindex[g_spare];
  
  refreshpalette();
  ustats();
}

void restore_undo()
{
  if(g_uindex[g_spare]==g_ubottom[g_spare])return;
  if(g_spare==0)g_undob[g_uindex[g_spare]]=g_map.clone();
  if(g_spare==1)g_undobs[g_uindex[g_spare]]=g_map.clone();
  g_uindex[g_spare]--;
  if(g_uindex[g_spare]<0)g_uindex[g_spare]=UNDOSTEPS;
  if(g_spare==0)g_map=g_undob[g_uindex[g_spare]].clone();
  if(g_spare==1)g_map=g_undobs[g_uindex[g_spare]].clone();
  
  refreshpalette();
  ustats();
}

void redo_undo()
{
  if(g_uindex[g_spare]==g_utop[g_spare])return;
  g_uindex[g_spare]++;
  if(g_uindex[g_spare]>UNDOSTEPS)g_uindex[g_spare]=0;
  if(g_spare==0)g_map=g_undob[g_uindex[g_spare]].clone();
  if(g_spare==1)g_map=g_undobs[g_uindex[g_spare]].clone();
  if(g_uindex[g_spare]>UNDOSTEPS)g_uindex[g_spare]=0;
  refreshpalette();
  ustats();
}

void spare() //dpaint style spare page
{
  if(g_spare==0){// in REAL page, change to SPARE page
     g_swappage=g_sparepage.clone();
     g_sparepage=g_map.clone();
     g_map=g_swappage.clone();
     frame.setTitle(sfilename);
  }
  else
  {// in SPARE page, change to REAL page
     g_swappage=g_sparepage.clone();
     g_sparepage=g_map.clone();
     g_map=g_swappage.clone();
     frame.setTitle(filename);
  }
  g_spare=1-g_spare;
  g_realfront=byte(g_farge);
  g_realback=byte(g_backg);
  refreshpalette();
}

void switcher(int di)
{
  // this achieves varieties of whole screen copying
  // needed for brush copy and pre-drawing the shapes when a
  // tool is active etc.
  switch(di)
  {
    case 0:
      g_rmap=g_map.clone();
    break;
    case 1:
      g_map=g_rmap.clone();
      for(int i=0;i<1024;i++){
        if(g_remdo[i]==1){
          g_remdo[i]=0;
          g_redo[i]=0;
        }
      }
    break;
    case 2:
      g_brush=g_map.clone();
    break;
    case 3:
       g_sparepage=g_map.clone();
    break;
    case 4:
       g_map=g_sparepage.clone();
    break;
  }
}
