// The preview window (BACKSPACE key)
// May be changed in the future

int g_preview=0;
int g_prevx=0;
int g_prevy=0;
int g_phandlex=0;
int g_phandley=0;
int g_pgrab=0;

int[] g_pwindow = new int[(320+16)*(256+16)];

void preview_window()
{
  int wix=X+16;
  int ofx=g_prevx;
  int ofy=g_prevy;
  if(g_preview==0)return;
  for(int y=0;y<Y+16;y++){  
    int ad=(ofy+y)*width;
    if(y+ofy>=0&&y+ofy<height){
      for(int x=0;x<X+16;x++){
          if(x+ofx>=0&&x+ofx<width){
            pixels[ad+x+ofx]=g_pwindow[x+y*wix];
          }
      }
    }
  }
}

void preview_box_drag()
{
    g_boxreconstruct=2;
    refresh_all();
    g_repanel=-1;
    update_ui(true);
}

void update_preview_window() //done at mousereleased
{
  int wix=X+16;
  
  if(g_preview==0)return;
  
  for(int y=0;y<Y+16;y++){
      for(int x=0;x<X+16;x++){
        
         if(y<8||x<8||y>=Y+8||x>=X+8){
           g_pwindow[y*wix+x]=g_rgb[g_map[0]];
         }else{
           g_pwindow[x+y*wix]=g_rgb[easygetcolor(x-8,y-8)];
         }
         if(y==0||y==Y+15||x==0||x==X+15)g_pwindow[y*wix+x]=g_rgb[257];
      }
  }
}

